#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import time
import wx
#import mumavlist
from . import mumapopup
from . import mumachecktitle
from   .mumamisc import *

class EditRecordDialog(wx.Dialog):

    ID_TC_ID_TITLE = wx.NewId()
    ID_TC_TITLE = wx.NewId()
    ID_TC_INTERPRET = wx.NewId()
    ID_TC_TIME = wx.NewId()
    ID_TC_DATE = wx.NewId()
    ID_TC_CODE = wx.NewId()
    ID_TC_COMPOSER = wx.NewId()
    ID_TC_LIMIT = wx.NewId()
    ID_TC_TAG_TITLE = wx.NewId()
    ID_TC_TAG_ARTIST = wx.NewId()
    ID_TC_TAG_ALBUM = wx.NewId()
    ID_BTN_COPY1 = wx.NewId()
    ID_BTN_COPY2 = wx.NewId()
    ID_CB_TT = wx.NewId()
    ID_CB_TA = wx.NewId()
    ID_RADIOCAMEL = wx.NewId()
    
    
    def __init__(self, parent, config, listwin, mumadb, onCheckMusicDir, writeToLogwin, onQuery, onPlayTitle, logger, edit = False):
        windowpos = (wx.Point(int(config['Window']['aerposx']),
                              int(config['Window']['aerposy'])))
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Add / Edit record', pos = windowpos)
        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)
        self.Bind(wx.EVT_IDLE, self.onIdle)
        self.parent = parent
        self.config = config
        self.record = config['Database']['lastedit']
        btnadj = int(config['Misc']['norm'] == 'False')
        self.listwin = listwin
        self.mumadb = mumadb
        self.onCheckMusicDir = onCheckMusicDir
        self.writeToLogwin = writeToLogwin
        self.onQuery = onQuery
        self.onPlayTitle = onPlayTitle
        self.logger = logger
        self.edit = edit
        self.index = 0
        self.id_title = '100000'
        self.ismp3 = False
        self.savemeta = False
        self.meta = {}
  
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        leftsizer = wx.BoxSizer(wx.VERTICAL)
        sbl = wx.StaticBox(self, -1, ' Database values ')
        block1 = wx.StaticBoxSizer(sbl, wx.HORIZONTAL)
        
        gbsz1 = wx.GridBagSizer(BORDER, BORDER)
        st = wx.StaticText(self, -1, 'Id_Title:')
        gbsz1.Add(st, wx.GBPosition(0, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tcid_title = wx.TextCtrl(self, self.ID_TC_ID_TITLE, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tcid_title, wx.GBPosition(0, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_ID_TITLE)
        st = wx.StaticText(self, -1, 'Title:')
        gbsz1.Add(st, wx.GBPosition(1, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tctitle = wx.TextCtrl(self, self.ID_TC_TITLE, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tctitle, wx.GBPosition(1, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_TITLE)
        st = wx.StaticText(self, -1, 'Interpreter:    ')
        gbsz1.Add(st, wx.GBPosition(2, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tcinterpret = wx.TextCtrl(self, self.ID_TC_INTERPRET, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tcinterpret, wx.GBPosition(2, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_INTERPRET)       
        st = wx.StaticText(self, -1, 'Duration:')
        gbsz1.Add(st, wx.GBPosition(3, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tctime = wx.TextCtrl(self, self.ID_TC_TIME, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tctime, wx.GBPosition(3, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_TIME)        
        st = wx.StaticText(self, -1, 'Date:')
        gbsz1.Add(st, wx.GBPosition(4, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tcdate = wx.TextCtrl(self, self.ID_TC_DATE, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tcdate, wx.GBPosition(4, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_DATE)       
        st = wx.StaticText(self, -1, 'Code:')
        gbsz1.Add(st, wx.GBPosition(5, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tccode = wx.TextCtrl(self, self.ID_TC_CODE, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tccode, wx.GBPosition(5, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_CODE)      
        st = wx.StaticText(self, -1, 'Composer:')
        gbsz1.Add(st, wx.GBPosition(6, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tccomposer = wx.TextCtrl(self, self.ID_TC_COMPOSER, style = wx.TE_PROCESS_ENTER)
        gbsz1.Add(self.tccomposer, wx.GBPosition(6, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onEdit, id = self.ID_TC_COMPOSER)
        self.butcopy1 = wx.Button(self, self.ID_BTN_COPY1, 'Copy Database values -> Music file tag values')
        gbsz1.Add(self.butcopy1, wx.GBPosition(7, 0), wx.GBSpan(1, 2), wx.LEFT | wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_BUTTON, self.onCopy1, id = self.ID_BTN_COPY1)
        self.Bind(wx.EVT_TEXT_ENTER, self.onOk)
        block1.Add(gbsz1, 1, wx.ALL, GAP)
        gbsz1.AddGrowableCol(1)
        
        sb2 = wx.StaticBox(self, -1, ' Music file tag values ')
        block2 = wx.StaticBoxSizer(sb2, wx.HORIZONTAL)
        gbsz2 = wx.GridBagSizer(BORDER, BORDER)
        self.cbtt = wx.CheckBox(self, self.ID_CB_TT, 'Tag title:')
        self.cbtt.SetValue(True)
        gbsz2.Add(self.cbtt, wx.GBPosition(0, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)        
        self.tctag_title = wx.TextCtrl(self, self.ID_TC_TAG_TITLE, style = wx.TE_PROCESS_ENTER)
        self.Bind(wx.EVT_TEXT, self.onMetaEdit, id = self.ID_TC_TAG_TITLE)
        gbsz2.Add(self.tctag_title, wx.GBPosition(0, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.cbta= wx.CheckBox(self, self.ID_CB_TA, 'Tag artist:')
        self.cbta.SetValue(True)
        gbsz2.Add(self.cbta, wx.GBPosition(1, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)        
        self.tctag_artist = wx.TextCtrl(self, self.ID_TC_TAG_ARTIST, style = wx.TE_PROCESS_ENTER)
        self.Bind(wx.EVT_TEXT, self.onMetaEdit, id = self.ID_TC_TAG_ARTIST)
        gbsz2.Add(self.tctag_artist, wx.GBPosition(1, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        st = wx.StaticText(self, -1, 'Tag album:  ')
        gbsz2.Add(st, wx.GBPosition(2, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.tctag_album = wx.TextCtrl(self, self.ID_TC_TAG_ALBUM, style = wx.TE_READONLY)
        self.tctag_album.SetBackgroundColour(wx.SystemSettings_GetColour(READONLY_COLOR))
        gbsz2.Add(self.tctag_album, wx.GBPosition(2, 1), wx.GBSpan(1, 1), wx.RIGHT | wx.GROW, GAP)
        self.rb = wx.RadioBox(self, self.ID_RADIOCAMEL, ' Copy mode ', wx.DefaultPosition, wx.DefaultSize,
                         ['Plain copy \t \t \t    ', 'CamelCase copy'], 1, wx.RA_SPECIFY_ROWS) # | wx.NO_BORDER)
        gbsz2.Add(self.rb, wx.GBPosition(3, 0), wx.GBSpan(1, 2), wx.LEFT | wx.RIGHT | wx.GROW, GAP)
        #self.Bind(wx.EVT_RADIOBOX, self.onRadioUnit, id = self.ID_RADIOCAMEL)
        self.butcopy2 = wx.Button(self, self.ID_BTN_COPY2, 'Copy Music file tag values -> Database values')
        gbsz2.Add(self.butcopy2, wx.GBPosition(4, 0), wx.GBSpan(1, 2), wx.LEFT | wx.RIGHT | wx.GROW, GAP)
        self.Bind(wx.EVT_BUTTON, self.onCopy2, id = self.ID_BTN_COPY2)
        block2.Add(gbsz2, 1, wx.ALL, GAP)
        gbsz2.AddGrowableCol(1)
        if self.config['Misc']['mutagenpresent'] == 'False' or not edit: 
            self.butcopy1.Disable()
            self.butcopy2.Disable()    
        
        #if edit:
        butback = wx.Button(self, wx.ID_BACKWARD)
        self.Bind(wx.EVT_BUTTON, self.onBackward, id = wx.ID_BACKWARD)        
        butforw = wx.Button(self, wx.ID_FORWARD)
        self.Bind(wx.EVT_BUTTON, self.onForward, id = wx.ID_FORWARD)
        butok = wx.Button(self, wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butcancel = wx.Button(self, wx.ID_CANCEL)
        self.Bind(wx.EVT_BUTTON, self.onCancel, id = wx.ID_CANCEL)
               
        butrow = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: butrow.AddStretchSpacer()
        butrow.Add(butok, btnadj, wx.GROW | wx.LEFT | wx.TOP | wx.BOTTOM, BORDER)
        #if edit:
        butrow.Add(butback, btnadj, wx.GROW | wx.LEFT | wx.TOP | wx.BOTTOM, BORDER)
        butrow.Add(butforw, btnadj, wx.GROW | wx.LEFT | wx.TOP | wx.BOTTOM, BORDER)
        butrow.Add(butcancel, btnadj, wx.GROW | wx.ALL, BORDER)
    
        leftsizer.Add(block1, 0, wx.GROW | LRT, BORDER)
        leftsizer.Add(block2, 0, wx.GROW | LRT, BORDER)
        leftsizer.Add(butrow, 0, wx.GROW | wx.LEFT | wx.RIGHT)
        
        sb3 = wx.StaticBox(self, -1, ' Id_Title and Title ordered by Title ')
        rightsizer = wx.StaticBoxSizer(sb3, wx.HORIZONTAL)
        self.sli = wx.ListCtrl(self, -1, size = wx.Size(100, -1), style = wx.LC_REPORT | wx.LC_NO_HEADER | wx.LC_HRULES | wx.BORDER_SUNKEN | wx.VSCROLL)
        imagelist = wx.ImageList(16, 16)
        self.fileidx = imagelist.Add(wx.ArtProvider.GetBitmap(wx.ART_COPY, wx.ART_OTHER, wx.Size(16, 16)))
        self.mfileidx = imagelist.Add(loadIcon('audiofile.png'))
        self.sli.AssignImageList(imagelist, wx.IMAGE_LIST_SMALL)        
        self.sli.InsertColumn(0, '')
        self.sli.InsertColumn(1, '')
        rightsizer.Add(self.sli, 1, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.onSortItemClicked, self.sli)
        self.Bind(wx.EVT_LIST_ITEM_RIGHT_CLICK, self.onItemProperties, self.sli)
        
        sizer.Add(leftsizer, 1, wx.GROW | wx.LEFT, 0)
        sizer.Add(rightsizer, 1, wx.GROW | wx.RIGHT | wx.TOP | wx.BOTTOM, BORDER)

        self.SetSizer(sizer)
        self.Fit()
        if not edit: butback.Enable(False)
        self.bgc = self.tcinterpret.GetBackgroundColour()
        self.getRecord()
        self.getTagInfo()
        self.maxreached = False
        collist = self.config['Misc']['hlcolor']
        self.hlcolor = (int(collist[0]), int(collist[1]), int(collist[2]))
        collist = self.config['Misc']['altcolor']
        self.altcolor = (int(collist[0]), int(collist[1]), int(collist[2]))

        self.updateSortedList()
        if not edit and self.maxreached:
            dlg = wx.MessageDialog(self, "Add record impossible - maximum of 99 entries reached",
                                   TITLE + ' - Add / Edit record', wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
    #-------------------------------------------------------------------------------------------

    def onIdle(self, event):
        if not self.edit and not self.savemeta:
            found, pathname = findTitleExt(self.config, self.id_title)
            if found:
                self.getTagInfo()
                self.Unbind(wx.EVT_IDLE)
        event.Skip()
    #-------------------------------------------------------------------------------------------

    def onItemProperties(self, event):
        index = event.GetIndex() 
        item = self.sli.GetItem(index, 0)
        id_title = item.GetText()
        if not isSpecialId(id_title):
            win = mumapopup.PropertyPopup(self, self.config, self.mumadb, id_title)
            pos = self.ClientToScreen((0,0))  # pos is the left top edge of the win
            sz = self.GetSize()               # sz is the size of the win
            win.Position((pos[0] + sz[0] / 2, pos[1] - sz[1] / 2), (0, sz[1]))       
            win.Popup()            
    #-------------------------------------------------------------------------------------------

    def onSortItemClicked(self, event):
        index = event.GetIndex() 
        item = self.sli.GetItem(index, 0)
        id_title = item.GetText()
        if not isSpecialId(id_title):
            self.onPlayTitle(id = id_title, top25 = False)
    #-------------------------------------------------------------------------------------------

    def updateSortedList(self):
        query = 'SELECT Id_Title, Title, Duration FROM muma_title WHERE Id_Title LIKE "%s%%" ORDER BY Title' % (self.id_title[0:4])
        records, self.matchcount = self.mumadb.getMatches(query)
        timesum = 0
        vindex = 0
        index = 0
        self.sli.DeleteAllItems()
        for index, entrytuple in enumerate(records):
            str_id_title = str(entrytuple[0])
            if str_id_title.endswith('00'):
                item = self.sli.InsertImageStringItem(index, str_id_title, self.fileidx)
            else:
                item = self.sli.InsertImageStringItem(index, str_id_title, self.mfileidx)
            if index % 2 == 0:
                self.sli.SetItemBackgroundColour(item, self.altcolor)
            if str_id_title == self.id_title:
                vindex = index
                self.sli.SetItemState(index, wx.LIST_STATE_SELECTED | wx.LIST_STATE_FOCUSED, wx.LIST_STATE_SELECTED | wx.LIST_STATE_FOCUSED)
            if isSpecialId(str_id_title):
                 self.sli.SetItemBackgroundColour(item, self.hlcolor)
            self.sli.SetStringItem(index, 1, entrytuple[1])
            if entrytuple[0] % 100: timesum += toSeconds(entrytuple[2])
        self.sli.SetColumnWidth(0, wx.LIST_AUTOSIZE)
        if not LINUX: self.sli.SetColumnWidth(0, self.sli.GetColumnWidth(0) + 5)
        self.sli.SetColumnWidth(1, wx.LIST_AUTOSIZE)
        rect = self.GetRect()
        sizex = max(rect[2] / 2 - self.sli.GetColumnWidth(0) - 50, self.sli.GetColumnWidth(1))
        self.sli.SetColumnWidth(1, sizex)
        self.sli.EnsureVisible(vindex)
        
        query = 'UPDATE muma_title SET Duration = "%s" WHERE Id_Title = "%s00"' % (toString(timesum), self.id_title[0:4])
        self.mumadb.execQuery(query)
        self.maxreached = index == 99
    #-------------------------------------------------------------------------------------------

    def onEdit(self, event):
        self.datachanged = True
        evtid = event.GetId()
        if evtid == self.ID_TC_ID_TITLE:
            self.record[0] = self.tcid_title.GetValue()
            copyenable = not isSpecialId(self.tcid_title.GetValue())
            self.butcopy1.Enable(copyenable)
            self.butcopy2.Enable(copyenable)
        elif evtid == self.ID_TC_TITLE:
            self.record[1] = self.tctitle.GetValue()
        elif evtid == self.ID_TC_INTERPRET:
            self.record[2] = self.tcinterpret.GetValue()
        elif evtid == self.ID_TC_TIME:
            self.record[3] = self.tctime.GetValue()
        elif evtid == self.ID_TC_DATE:       
            self.record[4] = self.tcdate.GetValue()
        elif evtid == self.ID_TC_CODE:
            self.record[5] = self.tccode.GetValue()
        else: # evtid == self.ID_TC_COMPOSER:
            self.record[6] = self.tccomposer.GetValue()
    #-------------------------------------------------------------------------------------------

    def onMetaEdit(self, event):
        self.savemeta = True
        evtid = event.GetId()
        if evtid == self.ID_TC_TAG_TITLE:
            self.meta['title'] = [self.tctag_title.GetValue()]
        else: # evtid == self.ID_TC_TAG_ARTIST:
            self.meta['artist'] = [self.tctag_artist.GetValue()]
    #-------------------------------------------------------------------------------------------

    def onCopy1(self, event):
        if isSpecialId(self.tcid_title.GetValue()): return
        self.savemeta = True
        self.meta['title'] = [self.tctitle.GetValue()]
        self.tctag_title.SetValue(self.tctitle.GetValue())
        self.meta['artist'] = [self.tcinterpret.GetValue()]
        self.tctag_artist.SetValue(self.tcinterpret.GetValue())
        self.tctag_title.SetBackgroundColour(self.bgc)
        self.tctag_artist.SetBackgroundColour(self.bgc)        
    #-------------------------------------------------------------------------------------------

    def onCopy2(self, event):
        if isSpecialId(self.tcid_title.GetValue()): return
        self.savemeta = True
        if self.cbtt.GetValue():
            if self.rb.GetSelection() == 1:
                [self.tctitle.SetValue(titleCase(self.meta['title'][0]))]
            else:
                [self.tctitle.SetValue(self.meta['title'][0])]
        if self.cbta.GetValue():
            if self.rb.GetSelection() == 1:
                [self.tcinterpret.SetValue(titleCase(self.meta['artist'][0]))]
            else:
                [self.tcinterpret.SetValue(self.meta['artist'][0])]
        self.tctag_title.SetBackgroundColour(self.bgc)
        self.tctag_artist.SetBackgroundColour(self.bgc)        
    #-------------------------------------------------------------------------------------------
    
    def getTagInfo(self):
        self.meta, self.ismp3, bitrate, duration = getTagInfo(self.config, self.tcid_title.GetValue())
        if 'title' in self.meta:
            self.tctag_title.SetValue(self.meta['title'][0])
        else:
            self.tctag_title.Clear()
        if 'artist' in self.meta:
            self.tctag_artist.SetValue(self.meta['artist'][0])
        else:
            self.tctag_artist.Clear()
        if 'album' in self.meta:
            self.tctag_album.SetValue(self.meta['album'][0])
        else:
            self.tctag_album.Clear()

        self.tctag_title.SetBackgroundColour(self.bgc)
        self.tctag_artist.SetBackgroundColour(self.bgc)
        self.savemeta = False        
        if not self.edit or isSpecialId(self.tcid_title.GetValue()):
            return

        if self.tctag_title.GetValue() != self.tctitle.GetValue():
            self.tctag_title.SetBackgroundColour(LRED)
        if self.tctag_artist.GetValue() != self.tcinterpret.GetValue():
            self.tctag_artist.SetBackgroundColour(LRED)
        self.savemeta = False
    #-------------------------------------------------------------------------------------------

    def getRecord(self):
        if self.edit or self.listwin.GetSelectedItemCount():
            self.index = self.listwin.GetNextItem(-1, wx.LIST_NEXT_ALL, wx.LIST_STATE_SELECTED)
            if self.listwin.GetColumn(0).GetText() == 'Id_Title':
                self.id_title = self.listwin.getColumnText(self.index, 0)
            query = 'SELECT * FROM muma_title WHERE Id_Title=%s' % (self.id_title)
            record, self.matchcount = self.mumadb.getMatches(query)
            self.record = list(record[0])
        else:
            self.record = self.config['Database']['lastedit']
            self.tctitle.SetFocus()
            
        if not self.edit:
            self.record[1] = ''
            self.record[3] = '00:0'
            self.tctag_title.SetValue('')
            self.tctag_artist.SetValue('')
            self.tctag_album.SetValue('')
            try:
                self.record[0] = str(int(self.record[0]) + 1)
            except:
                self.record[0] = '100000'
            self.id_title = self.record[0]
            self.Bind(wx.EVT_IDLE, self.onIdle)

        self.tcid_title.SetValue(str(self.record[0]))
        self.tctitle.SetValue(self.record[1])
        self.tcinterpret.SetValue(self.record[2])
        self.tctime.SetValue(self.record[3])
        self.tcdate.SetValue(self.record[4])
        self.tccode.SetValue(self.record[5])
        self.tccomposer.SetValue(self.record[6])
        self.datachanged = False
    #-------------------------------------------------------------------------------------------
                
    def updateDatabase(self):
        self.title_checked = False
        if self.datachanged:
            for i in range(len(self.record)):
                self.record[i] = self.record[i].strip()
                self.record[i] = self.record[i].replace(';', ',')
                self.record[i] = self.record[i].replace('"', "'")
            self.id_title = self.record[0]
            if not self.edit and self.config['Database']['addwarn'] == 'True':
                found, pathname = findTitleExt(self.config, self.id_title)
                if not found and not isSpecialId(self.id_title):
                    dlg = wx.MessageDialog(self, "A file with this Id_Title could not be found on device!\nCorrect associated filename?",
                                       TITLE + ' - Add / Edit record', wx.YES_NO | wx.YES_DEFAULT | wx.ICON_ERROR)
                    if dlg.ShowModal() == wx.ID_YES:
                        dlg.Destroy()
                        return False
                    else:
                        dlg.Destroy()
            try:
                i = int(self.id_title)
                if i < 0 or i > 999999: raise
                if not self.edit and not self.mumadb.isUniqueId(self.id_title): raise
            except:
                dlg = wx.MessageDialog(self, "the entered Id_Title '%s' is not valid or not unique" % (self.record[0]),
                                       TITLE + ' - Add / Edit record', wx.OK | wx.ICON_WARNING)
                dlg.ShowModal()
                dlg.Destroy()
                return False
            
            if self.record[1] == '':
                dlg = wx.MessageDialog(self, "This record has no Title information!\nCorrect entry?",
                                   TITLE + ' - Add / Edit record', wx.YES_NO | wx.YES_DEFAULT | wx.ICON_ERROR)
                if dlg.ShowModal() == wx.ID_YES:
                    dlg.Destroy()
                    return False
                else:
                    dlg.Destroy()
                
            if not isSpecialId(self.id_title):              
                metadummy, dummy2, dummy3, duration = getTagInfo(self.config, self.tcid_title.GetValue())
                try:
                    d = time.strptime(self.record[3], '%H:%M:%S')    # valid duration, i.e. not 02:66:05
                    self.record[3] = strftime('%H:%M:%S', d)
                except:
                    if duration == '00:00:00' and self.config['Database']['emptydt'] == 'False':
                        dlg = wx.MessageDialog(self, "the entered duration '%s' has no valid format or value" % (self.record[3]),
                                               TITLE + ' - Add / Edit record', wx.OK | wx.ICON_ERROR)
                        dlg.ShowModal()
                        dlg.Destroy()
                        return False
                    else:
                        self.record[3] = duration
                        self.tctime.SetValue(duration)
                if metadummy != {} and duration != self.record[3]:
                    self.record[3] = duration
                    self.tctime.SetValue(duration)
                                
                try:
                    t = time.strptime(self.record[4], '%Y-%m-%d')    # valid date, i.e. not 2004-02-31
                    self.record[4] = strftime('%Y-%m-%d', t)
                except:
                    if self.config['Database']['emptydt'] == 'False':  
                        dlg = wx.MessageDialog(self, "the entered date '%s' has no valid format or value" % (self.record[4]),
                                               TITLE + ' - Add / Edit record', wx.OK | wx.ICON_ERROR)
                        dlg.ShowModal()
                        dlg.Destroy()
                        return False
                    else:
                        pass
            
            if self.edit:
                self.mumadb.deleteRecordById(self.id_title)
                matchcount = 0
            else:
                query = 'SELECT Id_Title, Title, Interpreter FROM muma_title WHERE Title LIKE "%%%s%%" AND Interpreter LIKE "%%%s%%"' % (self.record[1], self.record[2])
                matches, matchcount = self.mumadb.getMatches(query)
        
            try:
                self.mumadb.putTitleRecord(self.record)
                if self.edit:
                    self.writeToLogwin("Edit - record with Id_Title = '%s' updated" % (self.id_title))
                else:    
                    self.writeToLogwin("Add - record with Id_Title = '%s' added" % (self.id_title))            
            except:
                dlg = wx.MessageDialog(self, "unable to add / update record with Id_Title = %s\n'PRIMARY KEY Id_Title is not unique!" % (self.id_title),
                                       TITLE + ' - update record', wx.OK | wx.ICON_ERROR)
                dlg.ShowModal()
                dlg.Destroy()
                return False

            if self.savemeta:
                try:
                    self.meta.save()
                    self.savemeta = False
                except:
                    pass

            if matchcount:
                match = matches[0]
                if str(match[0]).startswith('99'):
                    dlg = wx.MessageDialog(self, "G r e a t !\nWe have been waiting long for this '99xxx-title'", TITLE + ' - add record', wx.OK | wx.ICON_EXCLAMATION)
                    dlg.ShowModal()                      
                elif not isSpecialId(self.id_title) and self.config['Misc']['expert'] == 'True' \
                                                    and not str(match[0]).endswith('00'):
                    self.onQuery(enterparam = False, volume_id = self.id_title[0:4] + '%')
                    self.listwin.EnsureVisible(self.listwin.GetItemCount() - 1)
                    dlg = mumachecktitle.CheckTitle(self, self.id_title, self.config, self.mumadb, self.onCheckMusicDir, self.onPlayTitle, self.writeToLogwin, self.logger)
                    dlg.ShowModal()
                    self.title_checked = True
                    if not self.mumadb.titleExists(self.id_title):
                        self.logger.info("'%s' was a new entered title" % (self.id_title))
                        self.record[0] = str(int(self.id_title) - 1)
        
            self.config['Database']['lastedit'] = self.record
            
        elif self.savemeta:  # the data has not chaged but the meta data has
            try:
                self.meta.save()
                self.savemeta = False
            except:
                pass
          
        return True
    #-------------------------------------------------------------------------------------------

    def onForward(self, event):
        if not self.edit and self.maxreached:
            dlg = wx.MessageDialog(self, "Add record impossible - maximum of 99 entries reached",
                                   TITLE + ' - Add / Edit record', wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.onCancel()
            return
        
        olditemcount = self.listwin.GetItemCount()
        if self.updateDatabase():                     
            self.updateSortedList()
            #self.onQuery(enterparam = False, volume_id = self.id_title[0:4] + '%')
            if self.edit:
                #self.onQuery(enterparam = False) 
                newitemcount = self.listwin.GetItemCount()
                if (newitemcount == olditemcount and self.index >= newitemcount - 1) or \
                   (newitemcount < olditemcount and self.index >= newitemcount):
                    self.EndModal(wx.ID_OK)
                else:
                    if olditemcount == newitemcount:
                        self.listwin.Select(self.index, on = 0) # clear selection
                        self.index += 1
                    if self.index < self.listwin.GetItemCount():
                        self.listwin.Select(self.index)
                        self.listwin.EnsureVisible(self.index)
                        self.getRecord()
                        self.getTagInfo()
            else:
                self.onQuery(enterparam = False, volume_id = self.id_title[0:4] + '%')
                newitemcount = self.listwin.GetItemCount()
                index = self.listwin.FindItem(0, self.id_title)
                if index >= 0: self.index = index
                self.listwin.Select(self.index)
                self.listwin.EnsureVisible(self.index)
                self.getRecord()
                if olditemcount == newitemcount and not self.title_checked:
                    self.writeToLogwin('Add - nothing added - title field empty')
                    self.parent.showDeviceHint('title field empty')

        self.savemeta = False
    #-------------------------------------------------------------------------------------------
        
    def onBackward(self, event):
        if self.updateDatabase():
            #self.onQuery(enterparam = False)
            if self.index == 0:
                self.EndModal(wx.ID_OK)   
            else:
                self.listwin.Select(self.index, on = 0) # clear selection
                self.index -= 1
                self.listwin.Select(self.index)
                self.listwin.EnsureVisible(self.index)
                self.getRecord()
                self.getTagInfo()
                self.updateSortedList()
        self.savemeta = False
    #-------------------------------------------------------------------------------------------
        
    def onCancel(self, event = None):
        self.windowPosition()
        self.EndModal(wx.ID_CANCEL)
    #-------------------------------------------------------------------------------------------

    def onOk(self, event):
        if not self.updateDatabase(): return
        self.updateSortedList()
        if self.edit:
            #self.onQuery(enterparam = False)
            self.parent.reQuery()
        else:
            self.onQuery(enterparam = False, volume_id = self.id_title[0:4] + '%')        
        if LINUX:                                           # Fix for Win problem
            index = self.listwin.FindItem(0, self.id_title) # FindItem hangs on 
            if index >= 0: self.index = index               # itemcount == 0
        self.listwin.Select(self.index)
        self.listwin.EnsureVisible(self.index)
        
        self.windowPosition()
        self.EndModal(wx.ID_OK)
    #-------------------------------------------------------------------------------------------

    def windowPosition(self):
        windowrect = self.GetRect()
        self.config['Window']['aerposx'] = windowrect[0]
        self.config['Window']['aerposy'] = windowrect[1]
    #-------------------------------------------------------------------------------------------
        
    def onCloseWindow(self, event = None):
        self.Unbind(wx.EVT_IDLE)
        self.windowPosition()
        self.Destroy()
    #-------------------------------------------------------------------------------------------

    def getIndex(self):
        return self.index, self.id_title[0:4] + '%'
# - class EditQueryDialog(wx.Dialog):-----------------------------------------------------------
    
