#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx
from   .mumamisc import *

class SqlErrorDialog(wx.Dialog):
    ID_IGNORE = wx.NewId()
    
    def __init__(self, parent, message):        
        """  as """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Sql query parser')
        sizer = wx.BoxSizer(wx.VERTICAL)        
        stm = wx.StaticText(self, -1, 'The entered sql statement seems not to be valid.\nThe SqLite sql query parser reports:\n\n%s' % (message)) 
        sizer.Add(stm, 0, wx.GROW | LRT, BORDER)

        sl = wx.StaticLine(self, -1)
        sizer.Add(sl, 0, wx.GROW | LRT, BORDER)
        
        butignore = wx.Button(self, self.ID_IGNORE, '&Ignore')
        self.Bind(wx.EVT_BUTTON, self.onIgnore, id = self.ID_IGNORE)
        butedit = wx.Button(self, wx.ID_EDIT)
        self.Bind(wx.EVT_BUTTON, self.onEdit, id = wx.ID_EDIT)
               
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        row2.AddStretchSpacer()
        row2.Add(butedit, 0, wx.GROW | wx.ALL, BORDER)
        row2.Add(butignore, 0, wx.GROW | wx.ALL, BORDER)
        #row2.AddStretchSpacer()
    
        sizer.Add(row2, 0, wx.GROW | wx.LEFT | wx.RIGHT, BORDER)
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(350, -1))
        self.Fit()
        self.Centre()        
    #-------------------------------------------------------------------------------------------

    def onIgnore(self, event):
        self.EndModal(wx.ID_CANCEL)
    #-------------------------------------------------------------------------------------------

    def onEdit(self, event):
        self.EndModal(wx.ID_EDIT)
# - class SqlErrorDialog(wx.Dialog):---------------------------------------------------------------
    

  
class EditQueryDialog(wx.Dialog):

    ID_TC_NAME = wx.NewId()
    ID_TC_SQL = wx.NewId()
    ID_CB_DISTINCT = wx.NewId()
    ID_CB_FREEFORMAT = wx.NewId()
    ID_CB_JOIN = wx.NewId()
    ID_CB_HITPAR = wx.NewId()
    ID_CBI_ID_TITLE = wx.NewId()
    ID_CBI_TITEL = wx.NewId()
    ID_CBI_INTERPRET = wx.NewId()
    ID_CBI_ZEIT = wx.NewId()
    ID_CBI_DATUM = wx.NewId()
    ID_CBI_CODE = wx.NewId()
    ID_CBI_KOMPONIST = wx.NewId()
    ID_CBI_PLATZ = wx.NewId()
    ID_CBI_PDATUM = wx.NewId()
    ID_CBO_ID_TITLE = wx.NewId()
    ID_CBO_TITEL = wx.NewId()
    ID_CBO_INTERPRET = wx.NewId()
    ID_CBO_ZEIT = wx.NewId()
    ID_CBO_DATUM = wx.NewId()
    ID_CBO_CODE = wx.NewId()
    ID_CBO_KOMPONIST = wx.NewId()
    ID_CBO_PLATZ = wx.NewId()
    ID_CBO_PDATUM = wx.NewId()
    ID_TC_ID_TITEL = wx.NewId()
    ID_TC_TITEL = wx.NewId()
    ID_TC_INTERPRET = wx.NewId()
    ID_TC_ZEIT = wx.NewId()
    ID_TC_DATUM = wx.NewId()
    ID_TC_CODE = wx.NewId()
    ID_TC_KOMPONIST = wx.NewId()
    ID_TC_LIMIT = wx.NewId()
                
    def __init__(self, parent, config, database, updateQuerywin, queryname = '', clone = False):        
        """  as """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - New / Edit query')
        self.parent = parent
        self.config = config
        btnadj = int(config['Misc']['norm'] == 'False')
        self.database = database
        self.readonly_color = wx.SystemSettings_GetColour(READONLY_COLOR)
        self.updateQuerywin = updateQuerywin
        self.config.write()
        self.queryname = queryname
        
        self.edit = len(queryname)
        # new   ::= edit == 0, clone == False
        # clone ::= edit != 0, clone == True
        # edit  ::= edit != 0, clone == False
        if self.edit:
            if clone:
                self.querydata = self.config['Queries'][queryname].dict()
                self.queryname = 'clone_of_query-' + queryname
            else:
                self.querydata = self.config['Queries'][queryname]
        else:
            self.datetime = wx.DateTime_Now()
            self.querydata = initQueryExample()['All Titles']
            self.queryname = 'query-' + self.datetime.Format('%Y%m%d%H%M')

        sizer = wx.BoxSizer(wx.VERTICAL)        
        row1 = wx.BoxSizer(wx.HORIZONTAL)        
        self.nb = wx.Notebook(self, -1)
      #  self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.onPageChanged)
        row1.Add(self.nb) # , 0, wx.GROW | wx.ALL, 0)        
     
        self.initTab1(clone)
        self.initTab2()
        self.page3 = self.initTab3()
        self.nb.AddPage(self.page3, ' WHERE clauses ')
        self.nb.RemovePage(2)
        self.page4 = self.initTab4()
        self.nb.AddPage(self.page4, ' Free format ')
        self.nb.RemovePage(2)

        if self.querydata['hitpar'] == 'False':
            if self.querydata['freeformat'] == 'False':
                self.nb.AddPage(self.page3, ' WHERE clauses ')
            else:
                self.nb.AddPage(self.page4, ' Free format ')
        
        butok = wx.Button(self, wx.ID_OK, '&OK')
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butcancel = wx.Button(self, wx.ID_CANCEL, '&Cancel')
        self.Bind(wx.EVT_BUTTON, self.onCancel, id = wx.ID_CANCEL)        
               
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row2.AddStretchSpacer()
        row2.Add(butok, btnadj, wx.GROW | wx.ALL, GAP)
        row2.Add(butcancel, btnadj, wx.GROW | wx.ALL, GAP)
    
        sizer.Add(row1, 0, wx.GROW | LRT, BORDER)
        sizer.Add(row2, 1, wx.GROW | wx.ALL, GAP)
        self.SetSizer(sizer)
        self.Fit()
        self.Centre()
    #-------------------------------------------------------------------------------------------

    def initTab1(self, clone):
        page1 = wx.Panel(self.nb, -1)
        p1sizer = wx.BoxSizer(wx.VERTICAL)  
        fgsz = wx.FlexGridSizer(6, 2, 0, 0)
        fgsz.AddGrowableCol(1)
        fgsz.AddGrowableRow(5)
        st = wx.StaticText(page1, -1, 'Query name:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        if self.edit and not clone:
            self.tcname = wx.TextCtrl(page1, self.ID_TC_NAME, self.queryname, style = wx.TE_READONLY)
            self.tcname.SetBackgroundColour(self.readonly_color)
        else:
            self.tcname = wx.TextCtrl(page1, self.ID_TC_NAME, self.queryname)
        fgsz.Add(self.tcname, 0, wx.GROW | wx.ALL, GAP)
        st = wx.StaticText(page1, -1, 'Unique results:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.cb_distinct = wx.CheckBox(page1, self.ID_CB_DISTINCT, 'if checked - SELECT DISTINCT query')
        fgsz.Add(self.cb_distinct, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckDistinct, id = self.ID_CB_DISTINCT)
        self.cb_distinct.SetValue(self.querydata['distinct'] == 'True')
        st = wx.StaticText(page1, -1, 'Free format:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.cb_freeformat = wx.CheckBox(page1, self.ID_CB_FREEFORMAT, 'if checked - free editable WHERE clauses')
        fgsz.Add(self.cb_freeformat, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckFreeformat, id = self.ID_CB_FREEFORMAT)
        self.cb_freeformat.SetValue(self.querydata['freeformat'] == 'True')
        self.cb_freeformat.Enable(self.querydata['hitpar'] == 'False')
        st = wx.StaticText(page1, -1, 'Join tables:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.cb_join = wx.CheckBox(page1, self.ID_CB_JOIN, 'if checked - join table muma_place')
        fgsz.Add(self.cb_join, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckJoin, id = self.ID_CB_JOIN)
        self.cb_join.SetValue(self.querydata['join'] == 'True')
        st = wx.StaticText(page1, -1, 'Charts:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.cb_hitp = wx.CheckBox(page1, self.ID_CB_HITPAR, 'if checked - collect hitparade info')
        fgsz.Add(self.cb_hitp, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckHitpar, id = self.ID_CB_HITPAR)
        self.cb_hitp.SetValue(self.querydata['hitpar'] == 'True')
        self.cb_hitp.Enable(self.querydata['join'] == 'True')
        st = wx.StaticText(page1, -1, 'Sql string:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tcsql = wx.TextCtrl(page1, self.ID_TC_SQL, self.querydata['sql'],
                                 style = wx.TE_READONLY | wx.TE_MULTILINE)
        self.tcsql.SetBackgroundColour(self.readonly_color)
        fgsz.Add(self.tcsql, 0, wx.GROW | wx.ALL, GAP)        
        p1sizer.Add(fgsz, 1, wx.GROW | LRT, BORDER)
        page1.SetSizer(p1sizer)
        self.nb.AddPage(page1, ' Query info ')
    #-------------------------------------------------------------------------------------------

    def initTab2(self):
        page2 = wx.Panel(self.nb, -1)
        p2sizer = wx.BoxSizer(wx.VERTICAL)  
        sbz = wx.BoxSizer(wx.HORIZONTAL)
        sbl = wx.StaticBox(page2, -1, ' include column ')
        colsz = wx.StaticBoxSizer(sbl, wx.VERTICAL)
        sbr = wx.StaticBox(page2, -1, ' order by ')
        ordsz = wx.StaticBoxSizer(sbr, wx.VERTICAL)

        self.cbi_id_title = wx.CheckBox(page2, self.ID_CBI_ID_TITLE, 'Id_Title')
        colsz.Add(self.cbi_id_title, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_ID_TITLE)
        #self.cbi_id_title.Enable(False) 
        self.cbi_title = wx.CheckBox(page2, self.ID_CBI_TITEL, 'Title')
        colsz.Add(self.cbi_title, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_TITEL)
        self.cbi_interpret = wx.CheckBox(page2, self.ID_CBI_INTERPRET, 'Interpreter')
        colsz.Add(self.cbi_interpret, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_INTERPRET)
        self.cbi_zeit = wx.CheckBox(page2, self.ID_CBI_ZEIT, 'Duration')
        colsz.Add(self.cbi_zeit, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_ZEIT)
        self.cbi_datum = wx.CheckBox(page2, self.ID_CBI_DATUM, 'Date')
        colsz.Add(self.cbi_datum, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_DATUM)
        self.cbi_code = wx.CheckBox(page2, self.ID_CBI_CODE, 'Code')
        colsz.Add(self.cbi_code, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_CODE)
        self.cbi_komponist = wx.CheckBox(page2, self.ID_CBI_KOMPONIST, 'Composer')
        colsz.Add(self.cbi_komponist, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_KOMPONIST)
        self.cbi_platz = wx.CheckBox(page2, self.ID_CBI_PLATZ, 'Place')
        colsz.Add(self.cbi_platz, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_PLATZ)
        
        self.cbi_pdatum = wx.CheckBox(page2, self.ID_CBI_PDATUM, 'Pdate')
        colsz.Add(self.cbi_pdatum, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInclude, id = self.ID_CBI_PDATUM)
        sbz.Add(colsz, 1, wx.GROW | wx.ALL, GAP)
        
        self.cbo_id_title = wx.CheckBox(page2, self.ID_CBO_ID_TITLE, 'Id_Title')
        ordsz.Add(self.cbo_id_title, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_ID_TITLE)
        self.cbo_title = wx.CheckBox(page2, self.ID_CBO_TITEL, 'Title')
        ordsz.Add(self.cbo_title, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_TITEL)
        self.cbo_interpret = wx.CheckBox(page2, self.ID_CBO_INTERPRET, 'Interpreter')
        ordsz.Add(self.cbo_interpret, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_INTERPRET)
        self.cbo_zeit = wx.CheckBox(page2, self.ID_CBO_ZEIT, 'Duration')
        ordsz.Add(self.cbo_zeit, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_ZEIT)
        self.cbo_datum = wx.CheckBox(page2, self.ID_CBO_DATUM, 'Date')
        ordsz.Add(self.cbo_datum, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_DATUM)
        self.cbo_code = wx.CheckBox(page2, self.ID_CBO_CODE, 'Code')
        ordsz.Add(self.cbo_code, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_CODE)
        self.cbo_komponist = wx.CheckBox(page2, self.ID_CBO_KOMPONIST, 'Composer')
        ordsz.Add(self.cbo_komponist, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_KOMPONIST)
        self.cbo_platz = wx.CheckBox(page2, self.ID_CBO_PLATZ, 'Place')
        ordsz.Add(self.cbo_platz, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_PLATZ)     
        self.cbo_pdatum = wx.CheckBox(page2, self.ID_CBO_PDATUM, 'Pdate')
        ordsz.Add(self.cbo_pdatum, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckOrder, id = self.ID_CBO_PDATUM)
        sbz.Add(ordsz, 1, wx.GROW | wx.ALL, GAP)        
        self.checkIncludeAndOrder()

        isjoin = self.querydata['join'] == 'True'
        self.cbi_platz.Enable(isjoin)     
        self.cbo_platz.Enable(isjoin)       
        self.cbi_pdatum.Enable(isjoin)     
        self.cbo_pdatum.Enable(isjoin)       
        
        p2sizer.Add(sbz, 0, wx.GROW | LRT, GAP)
        page2.SetSizer(p2sizer)
        self.nb.AddPage(page2, ' Column infos ')
    #-------------------------------------------------------------------------------------------

    def initTab3(self):    
        page3 = wx.Panel(self.nb, -1)    
        p3sizer = wx.BoxSizer(wx.VERTICAL)
        fgsz = wx.FlexGridSizer(7, 2, 0, 0)
        fgsz.AddGrowableCol(1)
        st = wx.StaticText(page3, -1, 'Id_Title:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tcid_titel = wx.TextCtrl(page3, self.ID_TC_ID_TITEL, self.querydata['id_title'])
        fgsz.Add(self.tcid_titel, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_ID_TITEL)
        st = wx.StaticText(page3, -1, 'Title:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tctitel = wx.TextCtrl(page3, self.ID_TC_TITEL, self.querydata['title'])
        fgsz.Add(self.tctitel, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_TITEL)
        st = wx.StaticText(page3, -1, 'Interpreter:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tcinterpret = wx.TextCtrl(page3, self.ID_TC_INTERPRET, self.querydata['interpreter'])
        fgsz.Add(self.tcinterpret, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_INTERPRET)
        st = wx.StaticText(page3, -1, 'Duration:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tczeit = wx.TextCtrl(page3, self.ID_TC_ZEIT, self.querydata['duration'])
        fgsz.Add(self.tczeit, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_ZEIT)
        st = wx.StaticText(page3, -1, 'Date:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tcdatum = wx.TextCtrl(page3, self.ID_TC_DATUM, self.querydata['date'])
        fgsz.Add(self.tcdatum, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_DATUM)
        st = wx.StaticText(page3, -1, 'Code:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tccode = wx.TextCtrl(page3, self.ID_TC_CODE, self.querydata['code'])
        fgsz.Add(self.tccode, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_CODE)
        st = wx.StaticText(page3, -1, 'Composer:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        self.tckomponist = wx.TextCtrl(page3, self.ID_TC_KOMPONIST, self.querydata['composer'])
        fgsz.Add(self.tckomponist, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onWhereClause, id = self.ID_TC_KOMPONIST)
        
        p3sizer.Add(fgsz, 0, wx.GROW | LRT, GAP)
        page3.SetSizer(p3sizer)
        return page3
    #-------------------------------------------------------------------------------------------

    def initTab4(self):
        page4 = wx.Panel(self.nb, -1)
        p4sizer = wx.BoxSizer(wx.VERTICAL)  
        fgsz = wx.FlexGridSizer(2, 2, 0, 0)
        fgsz.AddGrowableCol(1)
        fgsz.AddGrowableRow(0)
        st = wx.StaticText(page4, -1, 'WHERE:')
        fgsz.Add(st, 0, wx.ALL, GAP)
        x = self.querydata['freewhere']
        self.tcfree = wx.TextCtrl(page4, self.ID_TC_NAME, self.querydata['freewhere'],
                                  style = wx.TE_MULTILINE)
        fgsz.Add(self.tcfree, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_TEXT, self.onFreeFormatText, id = self.ID_TC_NAME)
        fgsz.AddStretchSpacer()
        msgtext = wx.StaticText(page4, -1, "Parameter has format %param[1|2]%, i.e. Titel = '%param%'")
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        msgtext.SetFont(font)
        fgsz.Add(msgtext, 0, wx.GROW | wx.ALL, GAP)

        p4sizer.Add(fgsz, 1, wx.GROW | LRT, BORDER)
        page4.SetSizer(p4sizer)
        return page4
    #-------------------------------------------------------------------------------------------

    def createColumnList(self):
        newcols = []
        columns = self.querydata['columns']
        if 'Id_Title' in columns: newcols.append('Id_Title')
        if 'Title' in columns: newcols.append('Title')
        if 'Interpreter' in columns: newcols.append('Interpreter')
        if 'Duration' in columns: newcols.append('Duration')
        if 'Date' in columns: newcols.append('Date')
        if 'Code' in columns: newcols.append('Code')
        if 'Composer' in columns: newcols.append('Composer')
        if 'Place' in columns: newcols.append('Place')
        if 'Pdate' in columns: newcols.append('Pdate')
        self.querydata['columns'] = newcols
        return newcols        
    #-------------------------------------------------------------------------------------------

    def createWidthList(self):
        newwidth = []
        for i in range(len(self.createColumnList())):
            newwidth.append(120)
        self.querydata['colwidth'] = newwidth
    #-------------------------------------------------------------------------------------------
        
    def createSqlSelect(self):
        if self.querydata['distinct'] == 'True':
            return "SELECT DISTINCT %s" % (', '.join(self.createColumnList()))
        else:
            return "SELECT %s" % (', '.join(self.createColumnList()))
    #-------------------------------------------------------------------------------------------

    def createSqlFrom(self):
        if self.querydata['join'] == 'False':
            return ' FROM muma_title'
        else:
            return ' FROM muma_title, muma_place'
    #-------------------------------------------------------------------------------------------

    def createSqlWhere(self):
        if self.querydata['hitpar'] == 'True':
            sql = " WHERE Pdate BETWEEN date('%param%', '-3 days')\
AND date('%param%', '+3 days') AND Id_Title = Title_Id"
        else:                
            if self.querydata['freeformat'] == 'True':
                sql = ' WHERE %s' % (self.querydata['freewhere'])
            else:
                sql = ' WHERE Id_Title LIKE "%s" AND Title LIKE "%s" AND Interpreter LIKE "%s" \
AND Duration LIKE "%s" AND Date LIKE "%s" AND Code LIKE "%s" AND Composer LIKE "%s"' % (
                      self.querydata['id_title'], self.querydata['title'],
                      self.querydata['interpreter'], self.querydata['duration'], self.querydata['date'],
                      self.querydata['code'], self.querydata['composer'])
        sql = sql.replace("'", '"')
        return sql
    #-------------------------------------------------------------------------------------------

    def createOrderByList(self):
        neworder = []
        orderby = self.querydata['orderby']
        if 'Id_Title' in orderby: neworder.append('Id_Title')
        if 'Title' in orderby: neworder.append('Title')
        if 'Interpreter' in orderby: neworder.append('Interpreter')
        if 'Duration' in orderby: neworder.append('Duration')
        if 'Date' in orderby: neworder.append('Date')
        if 'Code' in orderby: neworder.append('Code')
        if 'Composer' in orderby: neworder.append('Composer')
        if 'Place' in orderby: neworder.append('Place')
        if 'Pdate' in orderby: neworder.append('Pdate')
        self.querydata['orderby'] = neworder
        return neworder
    #-------------------------------------------------------------------------------------------

    def createSqlOrderBy(self):
        orderbylist = self.createOrderByList()
        if len(orderbylist):
            retstr = ' ORDER BY '
            for item in orderbylist:
                retstr += '%s, ' % (item)
            return retstr[0:-2]
        else:
            return ''
    #-------------------------------------------------------------------------------------------

    def createSqlStatement(self):
        return '%s%s%s%s' % (self.createSqlSelect(), self.createSqlFrom(),
                             self.createSqlWhere(), self.createSqlOrderBy())
    #-------------------------------------------------------------------------------------------

    def onWhereClause(self, event):
        evtid = event.GetId()
        if evtid == self.ID_TC_ID_TITEL:
            self.querydata['id_title'] = self.tcid_titel.GetValue()
        elif evtid == self.ID_TC_TITEL:
            self.querydata['titel'] = self.tctitel.GetValue()
        elif evtid == self.ID_TC_INTERPRET:
            self.querydata['interpreter'] = self.tcinterpret.GetValue()
        elif evtid == self.ID_TC_ZEIT:
            self.querydata['duration'] = self.tczeit.GetValue()
        elif evtid == self.ID_TC_DATUM:
            self.querydata['date'] = self.tcdatum.GetValue()
        elif evtid == self.ID_TC_CODE:
            self.querydata['code'] = self.tccode.GetValue()
        else: # evtid == self.ID_TC_KOMPONIST:
            self.querydata['composer'] = self.tckomponist.GetValue()

        newsql = self.createSqlStatement()
        self.querydata['sql'] = newsql
        self.tcsql.SetValue(newsql)        
    #-------------------------------------------------------------------------------------------

    def onFreeFormatText(self, event):
        self.querydata['freewhere'] = self.tcfree.GetValue()
        newsql = self.createSqlStatement()
        self.querydata['sql'] = newsql
        self.tcsql.SetValue(newsql)
    #-------------------------------------------------------------------------------------------

    def checkIncludeAndOrder(self):
        removeitems = []
        columns = self.querydata['columns']
        self.cbi_id_title.SetValue('Id_Title' in columns)
        value = self.cbi_id_title.GetValue()
        self.cbo_id_title.Enable(value)
        if not value: removeitems.append('Id_Title')
        self.cbi_title.SetValue('Title' in columns)
        value = self.cbi_title.GetValue()
        self.cbo_title.Enable(value)
        if not value: removeitems.append('Title')        
        self.cbi_interpret.SetValue('Interpreter' in columns)
        value = self.cbi_interpret.GetValue()
        self.cbo_interpret.Enable(value)
        if not value: removeitems.append('Interpreter')        
        self.cbi_zeit.SetValue('Duration' in columns)
        value = self.cbi_zeit.GetValue()
        self.cbo_zeit.Enable(value)
        if not value: removeitems.append('Duration')        
        self.cbi_datum.SetValue('Date' in columns)
        value = self.cbi_datum.GetValue()
        self.cbo_datum.Enable(value)
        if not value: removeitems.append('Date')        
        self.cbi_code.SetValue('Code' in columns)
        value = self.cbi_code.GetValue()
        self.cbo_code.Enable(value)
        if not value: removeitems.append('Code')        
        self.cbi_komponist.SetValue('Composer' in columns)
        value = self.cbi_komponist.GetValue()
        self.cbo_komponist.Enable(value)
        if not value: removeitems.append('Composer')       
        self.cbi_platz.SetValue('Place' in columns)
        value = self.cbi_platz.GetValue()
        self.cbo_platz.Enable(value)
        if not value: removeitems.append('Place')
        self.cbi_pdatum.SetValue('Pdate' in columns)
        value = self.cbi_pdatum.GetValue()
        self.cbo_pdatum.Enable(value)
        if not value: removeitems.append('Pdate')

        for item in removeitems:
            try:    self.querydata['orderby'].remove(item)
            except: pass
        orderby = self.querydata['orderby']
        self.cbo_id_title.SetValue('Id_Title' in orderby)
        self.cbo_title.SetValue('Title' in orderby)
        self.cbo_interpret.SetValue('Interpreter' in orderby)
        self.cbo_zeit.SetValue('Duration' in orderby)
        self.cbo_datum.SetValue('Date' in orderby)
        self.cbo_code.SetValue('Code' in orderby)
        self.cbo_komponist.SetValue('Composer' in orderby)
        self.cbo_platz.SetValue('Place' in orderby)
        self.cbo_pdatum.SetValue('Pdate' in orderby) 
    #-------------------------------------------------------------------------------------------
        
    def onCheckDistinct(self, event):
        self.querydata['distinct'] = str(self.cb_distinct.GetValue())
        sql = self.createSqlStatement()                                
        self.querydata['sql'] = sql
        self.tcsql.SetValue(sql)
    #-------------------------------------------------------------------------------------------

    def onCheckHitpar(self, event):
        if self.cb_hitp.GetValue():
            self.querydata['hitpar'] = 'True'
            self.nb.RemovePage(2)
        else:
            self.querydata['hitpar'] = 'False'
            if self.cb_freeformat.GetValue():
                self.nb.AddPage(self.page4, ' Free format ')
            else:
                self.nb.AddPage(self.page3, ' WHERE clauses ')
        self.cb_freeformat.Enable(self.querydata['hitpar'] == 'False')
        sql = self.createSqlStatement()                                
        self.querydata['sql'] = sql
        self.checkIncludeAndOrder()
        self.tcsql.SetValue(sql)
    #-------------------------------------------------------------------------------------------

    def onCheckJoin(self, event):
        sql = self.querydata['sql']
        if self.cb_join.GetValue():
            self.querydata['join'] = 'True'
        else:
            self.querydata['join'] = 'False'
            if 'Place' in self.querydata['columns']: self.querydata['columns'].remove('Place')
            if 'Place' in self.querydata['orderby']: self.querydata['orderby'].remove('Place')
            if 'Pdate' in self.querydata['columns']: self.querydata['columns'].remove('Pdate')
            if 'Pdate' in self.querydata['orderby']: self.querydata['orderby'].remove('Pdate')
        
        isjoin = self.querydata['join'] == 'True'    
        self.cbi_platz.Enable(isjoin)     
        self.cbo_platz.Enable(isjoin)
        self.cbi_pdatum.Enable(isjoin)     
        self.cbo_pdatum.Enable(isjoin)
        self.cb_hitp.Enable(isjoin)
        
        sql = self.createSqlStatement()                                
        self.querydata['sql'] = sql
        self.checkIncludeAndOrder()
        self.tcsql.SetValue(sql)
    #-------------------------------------------------------------------------------------------

    def onCheckFreeformat(self, event = None):
        if self.cb_freeformat.GetValue():
            self.querydata['freeformat'] = 'True'
            self.nb.RemovePage(2)
            self.nb.AddPage(self.page4, ' Free format ')
        else:
            self.querydata['freeformat'] = 'False'
            self.nb.RemovePage(2)
            self.nb.AddPage(self.page3, ' WHERE clauses ')

        newsql = self.createSqlStatement()
        self.querydata['sql'] = newsql
        self.tcsql.SetValue(newsql)
    #-------------------------------------------------------------------------------------------

    def onCheckInclude(self, event):
        columns = self.querydata['columns']
        evtid = event.GetId()
        if evtid == self.ID_CBI_ID_TITLE:
            if self.cbi_id_title.GetValue():
                columns.append('Id_Title')
            else:
                columns.remove('Id_Title')
        elif evtid == self.ID_CBI_TITEL:
            if self.cbi_title.GetValue():
                columns.append('Title')
            else:
                columns.remove('Title')
        elif evtid == self.ID_CBI_INTERPRET:
            if self.cbi_interpret.GetValue():
                columns.append('Interpreter')
            else:
                columns.remove('Interpreter')
        elif evtid == self.ID_CBI_ZEIT:
            if self.cbi_zeit.GetValue():
                columns.append('Duration')
            else:
                columns.remove('Duration')
        elif evtid == self.ID_CBI_DATUM:
            if self.cbi_datum.GetValue():
                columns.append('Date')
            else:
                columns.remove('Date')
        elif evtid == self.ID_CBI_CODE:
            if self.cbi_code.GetValue():
                columns.append('Code')
            else:
                columns.remove('Code')
        elif evtid == self.ID_CBI_KOMPONIST:
            if self.cbi_komponist.GetValue():
                columns.append('Composer')
            else:
                columns.remove('Composer')
        elif evtid == self.ID_CBI_PLATZ:
            if self.cbi_platz.GetValue():
                columns.append('Place')
            else:
                columns.remove('Place')
        else:    # ID_CBI_PDATUM:
            if self.cbi_pdatum.GetValue():
                columns.append('Pdate')
            else:
                columns.remove('Pdate')
            
        self.createColumnList()
        self.createWidthList()
        self.checkIncludeAndOrder()
        sql = self.createSqlStatement()
        self.querydata['sql'] = sql
        self.tcsql.SetValue(sql)
    #-------------------------------------------------------------------------------------------

    def onCheckOrder(self, event):
        orderby = self.querydata['orderby']
        evtid = event.GetId()
        if evtid == self.ID_CBO_ID_TITLE:
            if self.cbo_id_title.GetValue():
                orderby.append('Id_Title')
            else:
                orderby.remove('Id_Title')
        elif evtid == self.ID_CBO_TITEL:
            if self.cbo_title.GetValue():
                orderby.append('Title')
            else:
                orderby.remove('Title')
        elif evtid == self.ID_CBO_INTERPRET:
            if self.cbo_interpret.GetValue():
                orderby.append('Interpreter')
            else:
                orderby.remove('Interpreter')
        elif evtid == self.ID_CBO_ZEIT:
            if self.cbo_zeit.GetValue():
                orderby.append('Duration')
            else:
                orderby.remove('Duration')
        elif evtid == self.ID_CBO_DATUM:
            if self.cbo_datum.GetValue():
                orderby.append('Date')
            else:
                orderby.remove('Date')
        elif evtid == self.ID_CBO_CODE:
            if self.cbo_code.GetValue():
                orderby.append('Code')
            else:
                orderby.remove('Code')
        elif evtid == self.ID_CBO_KOMPONIST:
            if self.cbo_komponist.GetValue():
                orderby.append('Composer')
            else:
                orderby.remove('Composer')
        elif evtid == self.ID_CBO_PLATZ:
            if self.cbo_platz.GetValue():
                orderby.append('Place')
            else:
                orderby.remove('Place')
        else:
            if self.cbo_pdatum.GetValue():
                orderby.append('Pdate')
            else:
                orderby.remove('Pdate')
            
        sql = self.createSqlStatement()                                
        self.querydata['sql'] = sql
        self.tcsql.SetValue(sql)
    #-------------------------------------------------------------------------------------------

    def onOk(self, event):
        # if self.parent.config['Queries'].has_key(self.tcname.GetValue()) and not self.edit: # (Python 2)
        if self.tcname.GetValue() in self.parent.config['Queries'] and not self.edit:            
            dlg = wx.MessageDialog(self, "The choosen queryname already exists!\nPlease use a different jobname.",
                                   TITLE + ' - New / Edit query', wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        err = self.database.checkSqlSyntax(self.querydata['sql'])
        if err != None:
            dlg = SqlErrorDialog(self, err)
            if dlg.ShowModal() != wx.ID_CANCEL:
                dlg.Destroy()
                return
            dlg.Destroy()

        event.Skip()
    #-------------------------------------------------------------------------------------------

    def onCancel(self, event):
        self.config.reload()      # read old values
        self.updateQuerywin()
        event.Skip()
    #-------------------------------------------------------------------------------------------

    def getValues(self):
        queryname = self.tcname.GetValue()
        self.querydata['name'] = queryname
        return self.querydata, queryname
# - class EditQueryDialog(wx.Dialog):-----------------------------------------------------------

  
class QueriesManDialog(wx.Dialog):
    
    ID_CLONE = wx.NewId()           

    def __init__(self, parent, config, database, updateQuerywin, writeToLogwin, index = 0):        
        """  add, edit or remove backup jobs """
        windowpos = (wx.Point(int(config['Window']['qmaposx']),
                              int(config['Window']['qmaposy'])))
        windowsize = (wx.Size(int(config['Window']['qmasizex']),
                              int(config['Window']['qmasizey'])))                
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Manage queries',
                           pos = windowpos, size = windowsize,
                           style = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
        self.Bind(wx.EVT_CLOSE, self.onButtonClose)
        self.Bind(wx.EVT_RIGHT_DOWN, self.onContext)
        self.parent = parent
        self.config = config
        btnadj = int(config['Misc']['norm'] == 'False')
        self.database = database
        self.updateQuerywin = updateQuerywin
        self.writeToLogwin = writeToLogwin
        sizer = wx.BoxSizer(wx.VERTICAL)
        gbsz = wx.GridBagSizer(BORDER, BORDER)      
        
        sb = wx.StaticBox(self, -1, ' Existing queries ')
        col1 = wx.StaticBoxSizer(sb, wx.HORIZONTAL)
        self.querylist = wx.ListBox(self, -1, size = wx.Size(155, -1),
                                    style = wx.LB_SINGLE | wx.LB_HSCROLL)
        col1.Add(self.querylist, 1, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_LISTBOX, self.onClickQuery)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onButtonEdit)
        self.Bind(wx.EVT_CHECKLISTBOX, self.onChecked)
        self.querylist.Bind(wx.EVT_RIGHT_DOWN, self.onContext)
        gbsz.Add(col1, wx.GBPosition(0, 0), wx.GBSpan(1, 1), wx.GROW)

        sb = wx.StaticBox(self, -1, ' Query info ')
        col2 = wx.StaticBoxSizer(sb, wx.HORIZONTAL)
        self.qi = wx.ListCtrl(self, -1, style = wx.LC_REPORT | wx.LC_NO_HEADER | \
                              wx.LC_SINGLE_SEL | wx.LC_HRULES | wx.BORDER_SUNKEN)
        self.qi.Bind(wx.EVT_RIGHT_DOWN, self.onContext)
        self.qi.InsertColumn(0, '')
        self.qi.InsertColumn(1, '')
        col2.Add(self.qi, 1, wx.GROW | wx.ALL, GAP)
        gbsz.Add(col2, wx.GBPosition(0, 1), wx.GBSpan(1, 3), wx.GROW)
                
        butnew = wx.Button(self, wx.ID_NEW)
        butedit = wx.Button(self, wx.ID_EDIT)
        butclone = wx.Button(self, self.ID_CLONE, 'C&lone')
        butrem = wx.Button(self, wx.ID_REMOVE)
        butclear = wx.Button(self, wx.ID_CLEAR, 'Cle&ar')
        butclose = wx.Button(self, wx.ID_CLOSE)
        self.Bind(wx.EVT_BUTTON, self.onButtonClose, id = wx.ID_CLOSE)
        self.Bind(wx.EVT_BUTTON, self.onButtonNew, id = wx.ID_NEW)
        self.Bind(wx.EVT_BUTTON, self.onButtonClone, id = self.ID_CLONE)
        self.Bind(wx.EVT_BUTTON, self.onButtonRem, id = wx.ID_REMOVE)
        self.Bind(wx.EVT_BUTTON, self.onButtonEdit, id = wx.ID_EDIT)
        self.Bind(wx.EVT_BUTTON, self.onButtonClear, id = wx.ID_CLEAR)
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row2.AddStretchSpacer()
        row2.Add(butnew, btnadj, wx.GROW | wx.RIGHT, GAP)
        row2.Add(butedit, btnadj, wx.GROW | wx.LEFT | wx.RIGHT, GAP)
        row2.Add(butclone, btnadj, wx.GROW | wx.LEFT | wx.RIGHT, GAP)
        row2.Add(butrem, btnadj, wx.GROW | wx.LEFT | wx.RIGHT, GAP)
        row2.Add(butclear, btnadj, wx.GROW | wx.LEFT | wx.RIGHT, GAP)
        row2.Add(butclose, btnadj, wx.GROW | wx.LEFT, GAP)
        gbsz.Add(row2, wx.GBPosition(1, 0), wx.GBSpan(1, 4), wx.GROW)

        self.initContextMenu()
        self.updateKeys()
        try:
            self.querylist.Select(index)
            self.onClickQuery(None, self.querynames[index])   
        except:
            pass

        gbsz.AddGrowableCol(0)
        gbsz.AddGrowableCol(1)
        gbsz.AddGrowableRow(0)

        sizer.Add(gbsz, 1, wx.GROW | wx.ALL, BORDER)
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(700, 500))
        #self.Fit()
        #self.Centre()        
    #-------------------------------------------------------------------------------------------

    def initContextMenu(self):
        self.popupID0 = wx.NewId()  
        self.popupID1 = wx.NewId()          
        self.popupID2 = wx.NewId()
        self.popupID3 = wx.NewId()
        self.popupID4 = wx.NewId()
        self.popupID5 = wx.NewId()
        
        self.Bind(wx.EVT_MENU, self.onButtonNew, id = self.popupID0)
        self.Bind(wx.EVT_MENU, self.onButtonEdit, id = self.popupID1)
        self.Bind(wx.EVT_MENU, self.onButtonClone, id = self.popupID2)
        self.Bind(wx.EVT_MENU, self.onButtonRem, id = self.popupID3)
        self.Bind(wx.EVT_MENU, self.onButtonClear, id = self.popupID4)
        self.Bind(wx.EVT_MENU, self.onButtonClose, id = self.popupID5)
    #-------------------------------------------------------------------------------------------

    def onContext(self, event):
        """ context menu handler """
        menu = wx.Menu()
        menu.Append(self.popupID0, 'New query')
        menu.Append(self.popupID1, 'Edit query')
        menu.Append(self.popupID2, 'Clone query')
        menu.Append(self.popupID3, 'Remove query')
        menu.Append(self.popupID4, 'Clear query')
        menu.AppendSeparator()
        menu.Append(self.popupID5, 'Close dialog')
        self.PopupMenu(menu)
        menu.Destroy()
    #-------------------------------------------------------------------------------------------      

    def onChecked(self, event):
        index = event.GetSelection()
        queryname = self.querylist.GetString(index)
        self.onClickQuery(queryname = queryname)
    #-------------------------------------------------------------------------------------------        

    def onClickQuery(self, event = None, queryname = ''):
        self.qi.DeleteAllItems()
        
        if len(self.config['Queries']) == 0: return
        if event != None:
            queryname = event.GetString()
        if (len(queryname) == 0):
            queryname = self.querynames[0]
        
        querydata = self.config['Queries'][queryname]
        
        self.qi.InsertStringItem(0, 'Query name:')
        self.qi.InsertStringItem(1, '')
        self.qi.InsertStringItem(2, 'Parameter:')
        self.qi.InsertStringItem(3, 'Join tables:')
        self.qi.InsertStringItem(4, 'Charts:')
        self.qi.InsertStringItem(5, 'Display cols:')
        self.qi.InsertStringItem(6, 'Order by:')
        self.qi.InsertStringItem(7, '')   
        self.qi.InsertStringItem(8, 'Sql statement:')
        self.qi.SetColumnWidth(0, wx.LIST_AUTOSIZE)
        
        self.qi.SetStringItem(0, 1, queryname)
        self.qi.SetStringItem(2, 1, str('%param' in querydata['sql']))
        self.qi.SetStringItem(3, 1, querydata['join'])
        self.qi.SetStringItem(4, 1, querydata['hitpar']) 
        self.qi.SetStringItem(5, 1, ', '.join(querydata['columns']))
        self.qi.SetStringItem(6, 1, ', '.join(querydata['orderby']))
        self.qi.SetStringItem(8, 1, querydata['sql'])
        self.qi.SetColumnWidth(1, wx.LIST_AUTOSIZE)
    #-------------------------------------------------------------------------------------------

    def onButtonClone(self, event):
        queryids = self.querylist.GetSelections()       
        if len(queryids):
            queryname = self.querylist.GetString(queryids[0])                       
            dlg = EditQueryDialog(self, self.config, self.database, self.updateQuerywin, queryname, True)
            if dlg.ShowModal() == wx.ID_OK:
                querydata, queryname = dlg.getValues()
                self.config['Queries'][queryname] = querydata
                self.writeToLogwin('Queries - 1 query (%s) added to list' % (queryname))
                self.updateKeys()
                self.onClickQuery(queryname = queryname)            
            dlg.Destroy()
            self.querylist.Select(self.querynames.index(queryname))
        else:
            try:
                self.querylist.Select(0)
            except:
                pass            
        self.Layout()        
    #-------------------------------------------------------------------------------------------

    def onButtonClear(self, event):
        querynames = list(self.config['Queries'].keys())
        querynames.remove('QuickQuery')
        querynames.remove('AlbumTitles')
        querynames.remove('AddRecord')
        for queryname in querynames:
            del self.config['Queries'][queryname]
        self.updateKeys()
        self.onClickQuery()   
        self.writeToLogwin('Queries - all queries removed from list', RED)
        self.Layout()
    #-------------------------------------------------------------------------------------------

    def windowPosition(self):
        windowrect = self.GetRect()
        self.config['Window']['qmaposx'] = windowrect[0]
        self.config['Window']['qmaposy'] = windowrect[1]
        self.config['Window']['qmasizex'] = windowrect[2]
        self.config['Window']['qmasizey'] = windowrect[3]
    #-------------------------------------------------------------------------------------------

    def onButtonClose(self, event):
        self.windowPosition()
        self.Destroy()
    #-------------------------------------------------------------------------------------------
        
    def onButtonNew(self, event):
        dlg = EditQueryDialog(self, self.config, self.database, self.updateQuerywin)
        queryname = ''
        if dlg.ShowModal() == wx.ID_OK:
            querydata, queryname = dlg.getValues()
            self.config['Queries'][queryname] = querydata
            self.writeToLogwin('Queries - 1 query (%s) added to list' % (queryname))
            self.updateKeys()
            self.onClickQuery(queryname = queryname)            
        dlg.Destroy()
        if queryname:
            self.querylist.Select(self.querynames.index(queryname))
        else:
            try:
                self.querylist.Select(0)
            except:
                pass            
        self.Layout()
    #-------------------------------------------------------------------------------------------

    def onButtonRem(self, event = None):
        queryids = self.querylist.GetSelections() 
        if len(queryids):
            queryname = self.querylist.GetString(queryids[0])
            del self.config['Queries'][queryname]      
            self.writeToLogwin("Queries - query '%s' removed from list" % (queryname))
        else:
            self.writeToLogwin('Queries - there is no query to remove')
        self.updateKeys()
        self.qi.DeleteAllItems()
        self.onClickQuery()
        try:
            self.querylist.Select(0)
        except:
            pass            
        self.Layout()
    #-------------------------------------------------------------------------------------------

    def onButtonEdit(self, event):
        queryids = self.querylist.GetSelections()        
        if len(queryids):
            queryname = self.querylist.GetString(queryids[0])
            dlg = EditQueryDialog(self, self.config, self.database, self.updateQuerywin, queryname)
            if dlg.ShowModal() == wx.ID_OK:
                querydata, queryname = dlg.getValues()
                self.config['Queries'][queryname] = querydata
            dlg.Destroy()
            self.updateKeys()
            self.onClickQuery(queryname = queryname)
            self.querylist.Select(self.querynames.index(queryname))
        self.Layout()
    #-------------------------------------------------------------------------------------------

    def updateKeys(self):
        self.querynames = list(self.config['Queries'].keys())
        self.querynames.remove('QuickQuery')
        self.querynames.remove('AlbumTitles')
        self.querynames.remove('AddRecord')
        self.querynames.sort()
        self.querylist.Set(self.querynames)
        self.updateQuerywin()     
# - class QueriesManDialog(wx.Dialog):----------------------------------------------------------

